<?php
/**
 * 备库申请
 */

namespace app\admin\controller;

use app\BaseController;
use think\facade\Db;
use think\App;

class Resign extends BaseController
{
    public $post="";
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->post = $this->request->post();
//        $token = isset($this->post['token']) ? trim($this->post['token']) : "";
//        if($token==""){
//            return error_show(101,'token不能为空');
//        }
//        $effetc = VerifyTokens($token);
//        if(!empty($effetc) && $effetc['code']!=0) {
//            return error_show($effetc['code'], $effetc['message']);
//        }
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !=="" ? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !=="" ? intval($this->post['size']):"10";
        $where =['is_del'=>0];
        $bkcode = isset($this->post['bk_code']) && $this->post['bk_code']!="" ? trim($this->post['bk_code']):"";
        if($bkcode!=""){
           $where['bk_code'] = $bkcode;
        }
        $good_code = isset($this->post['good_code']) && $this->post['good_code']!="" ? trim($this->post['good_code']):"";
        if($good_code!=""){
            $where['good_code'] = $good_code;
        }

        $good_type_code = isset($this->post['good_type_code']) && $this->post['good_type_code']!="" ? trim($this->post['good_type_code']):"";
        if($good_type_code!=""){
            $where['good_type_code'] = $good_type_code;
        }
        $wsm_code = isset($this->post['wsm_code']) && $this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code!=""){
            $where['wsm_code'] = $wsm_code;
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name']!="" ? trim($this->post['good_name']):"";
        if($good_name!=""){
            $where['good_name'] = Db::raw(" like '%{$good_name}%'");
        }

        $apply_name = isset($this->post['apply_name']) && $this->post['apply_name']!="" ? trim($this->post['apply_name']):"";
        if($apply_name!=""){
            $where['apply_name'] =Db::Raw("like '%{$apply_name}%'");
        }
        $status = isset($this->post['status']) && $this->post['status']!=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where['status'] = $status;
        }

        $start = isset($this->post['start']) && $this->post['start']!=="" ? $this->post['start']:"";
        if($start!==""){
            $where['addtime'] = Db::Raw(">= '{$start}'");
        }
        $end = isset($this->post['end']) && $this->post['end']!=="" ? $this->post['end']:"";
        if($end!==""){
            $where['addtime'] = Db::Raw("<= '{$end}'");
        }
        $count=Db::name("purchease")->where($where)->count();
        $total = ceil($count/$size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name("purchease")->where($where)->page($page,$size)->order("addtime desc")->select();
        return app_show(0,"获取成功",["list"=>$list,"count"=>$count]);
    }

    public  function add(){
        $token = isset($this->post['token']) ? trim($this->post['token']) : "";
        if($token==""){
            return error_show(101,'token不能为空');
        }
        $good_code = isset($this->post['good_code'])&&$this->post['good_code']!="" ? trim($this->post['good_code']):"";
        if($good_code==""){
            return error_show(1002,'参数good_code 不能为空');
        }
        $good = Db::name("good")->where(['good_code'=>$good_code,'is_del'=>0])->find();
        if(empty($good)){
            return error_show(1002,'未找到商品数据');
        }
        $good_type_code = isset($this->post['good_type_code'])&&$this->post['good_type_code']!="" ? trim($this->post['good_type_code'])
            :"";
        if($good_type_code!==""){
            $good_type= Db::name("good_type")->where(['good_code'=>$good_code,'is_del'=>0,'type_code'=>$good_type_code])
                ->find();
            if(empty($good_type)){
                return error_show(1002,'未找到商品属性数据');
            }
        }

        $good_num = isset($this->post['good_num'])&&$this->post['good_num']!=="" ? intval($this->post['good_num']) :"";
        if($good_num==''){
            return error_show(1002,'参数good_num 不能为空或零');
        }
        $wsm_code = isset($this->post['wsm_code'])&&$this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code==""){
            return error_show(1002,'参数wsm_code 不能为空');
        }
        $wsminfo = Db::name("warehouse_info")->where(['wsm_code'=>$wsm_code,"is_del"=>0])->find();
        if(empty($wsminfo)){
            return error_show(1002,'未找到仓库数据');
        }
        $lastime = isset($this->post['lastime'])&&$this->post['lastime']!="" ? $this->post['lastime']:"";
        if($lastime==""){
            return error_show(1002,'参数lastime 不能为空');
        }
        $data = GetUserInfo($token);
        if((!empty($data) && $data['code']!=0) ||empty($data) ){
            return error_show($data['code'],$data['message']);
        }
        $userinfo = $data['data'];
        $bk_code=makeNo("BK");
        $info = [
            "good_code"=>$good_code,
            "good_name"=>$good['good_name'],
            "good_num"=>$good_num,
            "good_type_code"=>$good_type_code,
            "wsm_code"=>$wsm_code,
            "lasttime"=>$lastime,
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s"),
            "apply_id"=>$userinfo['id'],
            "apply_name"=>$userinfo['nickname'],
            "bk_code"=>$bk_code
        ];
        $in = Db::name("purchease")->insert($info);
        return $in ? app_show(0,"新建成功",['bk_code'=>$bk_code]):error_show(1005,"新建失败");
    }

    public function info(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $info = Db::name("purchease")->where(["id"=>$id,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1002,'未找到数据');
        }
        $info['wsm_name']="";
        if($info['wsm_code']!=""){
            $wsm = Db::name("warehouse_info")->where(['wsm_code'=>$info['wsm_code'],"is_del"=>0])->find();
            $info['wsm_name']=isset($wsm) &&$wsm['name']!=""?$wsm['name']:"";
        }
        return app_show(0,"获取成功",$info);
    }
    public  function edit(){
        $token = isset($this->post['token']) ? trim($this->post['token']) : "";
        if($token==""){
            return error_show(101,'token不能为空');
        }
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $info = Db::name("purchease")->where(["id"=>$id,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1002,'未找到数据');
        }
        $good_code = isset($this->post['good_code'])&&$this->post['good_code']!="" ? trim($this->post['good_code']):"";
        if($good_code==""){
            return error_show(1002,'参数good_code 不能为空');
        }
        $good = Db::name("good")->where(['good_code'=>$good_code,'is_del'=>0])->find();
        if(empty($good)){
            return error_show(1002,'未找到商品数据');
        }
        $good_type_code = isset($this->post['good_type_code'])&&$this->post['good_type_code']!="" ? trim($this->post['good_type_code'])
            :"";
     if($good_type_code!=''){
         $good_type= Db::name("good_type")->where(['good_code'=>$good_code,'is_del'=>0,'type_code'=>$good_type_code])
             ->find();
         if(empty($good_type)){
             return error_show(1002,'未找到商品属性数据');
         }
     }

        $good_num = isset($this->post['good_num'])&&$this->post['good_num']!=="" ? intval($this->post['good_num']) :"";
        if($good_num==''){
            return error_show(1002,'参数good_num 不能为空或零');
        }
        $wsm_code = isset($this->post['wsm_code'])&&$this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code==""){
            return error_show(1002,'参数wsm_code 不能为空');
        }
        $wsminfo = Db::name("warehouse_info")->where(['wsm_code'=>$wsm_code,"is_del"=>0])->find();
        if(empty($wsminfo)){
            return error_show(1002,'未找到仓库数据');
        }
        $lastime = isset($this->post['lastime'])&&$this->post['lastime']!="" ? $this->post['lastime']:"";
        if($lastime==""){
            return error_show(1002,'参数lastime 不能为空');
        }
        $data = GetUserInfo($token);
        if((!empty($data) && $data['code']!=0) ||empty($data) ){
            return error_show($data['code'],$data['message']);
        }
        $userinfo = $data['data'];
        $up = [
            "good_code"=>$good_code,
            "good_name"=>$good['good_name'],
            "good_num"=>$good_num,
            "good_type_code"=>$good_type_code,
            "wsm_code"=>$wsm_code,
            "lasttime"=>$lastime,
            "updatetime"=>date("Y-m-d H:i:s"),
            "apply_id"=>$userinfo['id'],
            "apply_name"=>$userinfo['nickname']
        ];
        $in = Db::name("purchease")->where($info)->save($up);
        return $in ? app_show(0,"更新成功"):error_show(1005,"更新失败");
    }

    public function delete(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $info = Db::name("purchease")->where(["id"=>$id,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1002,'未找到数据');
        }
        $info['is_del']=1;
        $info['updatetime']=date("Y-m-d H:i:s");
        $up = Db::name("purchease")->update($info);
        return $up ? app_show(0,"删除成功"):error_show(1005,"删除失败");
    }

    public function status(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $info = Db::name("purchease")->where(["id"=>$id,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1002,'未找到数据');
        }
        $status = isset($this->post['status'])&&$this->post['status']!=='' ? intval($this->post['status']) : "";
        if($status===""){
            return error_show(1001,'status不能为空');
        }
        $info['status']= $status;
        $info['updatetime']=date("Y-m-d H:i:s");
        $up = Db::name("purchease")->update($info);
        return $up ? app_show(0,"更新成功"):error_show(1005,"更新失败");
    }


    public  function addFeed(){
        $token = isset($this->post['token']) ? trim($this->post['token']) : "";
        if($token==""){
            return error_show(101,'token不能为空');
        }
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $info = Db::name("purchease")->where(["id"=>$id,"is_del"=>0])->find();
        if(empty($info)){
            return error_show(1002,'未找到备库数据');
        }
        if($info['status']!=1){
            return error_show(1002,'备库数据状态有误');
        }
        $num = isset($this->post['num']) && $this->post['num']!=="" ? intval($this->post['num']):"";
        if($num==''){
            return error_show(1002,'参数num 不能为空或零');
        }
        $expecttime = isset($this->post['expecttime'])&&$this->post['expecttime']!=''?$this->post['expecttime'] :"";
        if($expecttime==''){
            return error_show(1002,'参数expecttime 不能为空');
        }
        $wsm_code = isset($this->post['wsm_code'])&&$this->post['wsm_code']!="" ? trim($this->post['wsm_code']):"";
        if($wsm_code==""){
            return error_show(1002,'参数wsm_code 不能为空');
        }
        $wsminfo = Db::name("warehouse_info")->where(['wsm_code'=>$wsm_code,"is_del"=>0])->find();
        if(empty($wsminfo)){
            return error_show(1002,'未找到仓库数据');
        }
        $supplierNo = isset($this->post['supplierNo'])&&$this->post['supplierNo']!="" ? trim($this->post['supplierNo']):"";
        if($supplierNo==""){
            return error_show(1002,'参数supplierNo 不能为空');
        }
        $supplie = Db::name("supplier")->where(['code'=>$supplierNo,"is_del"=>0])->find();
        if(empty($supplie)){
            return error_show(1002,'未找到供应商');
        }
        $good_price = isset($this->post['good_price'])&&$this->post['good_price']!=="" ? $this->post['good_price']:"";
        if($good_price===""){
            return error_show(1002,'参数good_price 不能为空');
        }
       $pakge_fee = isset($this->post['pakge_fee'])&&$this->post['pakge_fee']!=="" ? $this->post['pakge_fee']:0;
       $cert_fee = isset($this->post['cert_fee'])&&$this->post['cert_fee']!=="" ? $this->post['cert_fee']:0;
       $open_fee = isset($this->post['open_fee'])&&$this->post['open_fee']!=="" ? $this->post['open_fee']:0;
       $delivery_fee = isset($this->post['delivery_fee'])&&$this->post['delivery_fee']!=="" ? $this->post['delivery_fee']:0;
       $mark_fee = isset($this->post['mark_fee'])&&$this->post['mark_fee']!=="" ? $this->post['mark_fee']:0;
       $teach_fee = isset($this->post['teach_fee'])&&$this->post['teach_fee']!=="" ? $this->post['teach_fee']:0;
       $nake_fee = isset($this->post['nake_fee'])&&$this->post['nake_fee']!=="" ? $this->post['nake_fee']:0;
       $weight = isset($this->post['weight'])&&$this->post['weight']!=="" ? $this->post['weight']:0;
       $diff_weight =isset($this->post['diff_weight'])&&$this->post['diff_weight']!=="" ? $this->post['diff_weight']:0;
       $diff_price =isset($this->post['diff_price'])&&$this->post['diff_price']!=="" ? $this->post['diff_price']:0;
       $remark =isset($this->post['remark'])&&$this->post['remark']!=="" ? $this->post['remark']:'';
        $data = GetUserInfo($token);
        if((!empty($data) && $data['code']!=0) ||empty($data) ){
            return error_show($data['code'],$data['message']);
        }
        $userinfo = $data['data'];
        $data=[
            "bkcode"=>$info['bk_code'],
            "warehouse"=>$wsm_code,
            "num"=>$num,
            'expecttime'=>$expecttime,
            'supplier'=>isset($supplie) && $supplie['name']!=''? $supplie['name']:'',
            'good_price'=>$good_price,
            'pakge_fee'=>$pakge_fee,
            'cert_fee'=>$cert_fee,
            'open_fee'=>$open_fee,
            'mark_fee'=>$mark_fee,
            'teach_fee'=>$teach_fee,
            'nake_fee'=>$nake_fee,
            'delivery_fee'=>$delivery_fee,
            'weight'=>$weight,
            'remark'=>$remark,
            'diff_weight'=>$diff_weight,
            'diff_price'=>$diff_price,
            'purchaser'=>$userinfo['nickname'],
            'purchaser_id'=>$userinfo['id'],
            "addtime"=>date("Y-m-d H:i:s"),
            "updatetime"=>date("Y-m-d H:i:s")
        ];
        $in = Db::name('purchease_feedback')->insert($data);
        return $in ? app_show(0,"新建成功"):error_show(1005,"新建失败");
    }

    public function delFeed(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $feed = Db::name("purchease_feedback")->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($feed)){
            return error_show(1004,'未找到数据');
        }
        if($feed['status']==1){
            return error_show(1004,'反馈数据已采用无法删除');
        }
        $feed['is_del']= 1;
        $feed['updatetime']=date("Y-m-d H:i:s");
        $up = Db::name("purchease_feedback")->update($feed);
        return $up ? app_show(0,"删除成功"):error_show(1005,"删除失败");
    }

    public function infoFeed(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $feed = Db::name("purchease_feedback")->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($feed)){
            return error_show(1004,'未找到数据');
        }
        $feed['wsm_name']="";
        if($feed['warehouse']!=""){
            $wsm = Db::name("warehouse_info")->where(['wsm_code'=>$feed['warehouse'],"is_del"=>0])->find();
            $feed['wsm_name']=isset($wsm) &&$wsm['name']!=""?$wsm['name']:"";
        }
        return app_show(0,"获取成功",$feed);
    }

    public function changeFeed(){
        $id = isset($this->post['id']) ? intval($this->post['id']) : "";
        if($id==""){
            return error_show(1001,'id不能为空');
        }
        $feed = Db::name("purchease_feedback")->where(['id'=>$id,'is_del'=>0])->find();
        if(empty($feed)){
            return error_show(1004,'未找到数据');
        }
        $status = isset($this->post['status'])&& $this->post['status']!=='' ? intval($this->post['status']) : "";
        if($status==""){
            return error_show(1001,'参数status 不能为空');
        }
        $remark = isset($this->post['remark'])&& $this->post['remark']!=='' ? trim($this->post['remark']) : "";
        Db::startTrans();
        try{
            $feed['remark']= $remark;
            $feed['status']= $status;
            $feed['updatetime']=date("Y-m-d H:i:s");
            $up = Db::name("purchease_feedback")->update($feed);
            if($up){
                if($status==1){
                  //  $ware = Db::name("warehouse_addr")->where(["wsm_code"=>$feed['warehouse'],"is_del"=>0])->find();
                    $purse = Db::name("purchease")->where(['bk_code'=>$feed['bkcode'],"is_del"=>0])->find();
                    if(empty($purse)){
                        Db::rollback();
                        return error_show(1001,'未找到备库申请数据');
                    }
                    $supplier = Db::name("supplier")->where(["code"=>$feed['supplier']])->find();
                    $inw = makeNo("CG");
                    $data=[
                        "bkcode"=>$feed['bkcode'],
                        'cgdNo'=>$inw,
                        "wsm_code"=>$feed['warehouse'],
                        "good_code"=>$purse['good_code'],
                        "good_name"=>$purse['good_name'],
                        "good_type_code"=>$purse['good_type_code'],
                        "good_num"=>$purse['good_num'],
                        "send_num"=>0,
                        "wsend_num"=>$purse['good_num'],
                        'good_price'=>$feed['good_price'],
                        "total_fee"=>$feed['good_price'],
                        'pakge_fee'=>$feed['pakge_fee'],
                        'cert_fee'=>$feed['cert_fee'],
                        'open_fee'=>$feed['open_fee'],
                        'mark_fee'=>$feed['mark_fee'],
                        'teach_fee'=>$feed['teach_fee'],
                        'nake_fee'=>$feed['nake_fee'],
                        'delivery_fee'=>$feed['delivery_fee'],
                        'weight'=>$feed['weight'],
                        'diff_weight'=>$feed['diff_weight'],
                        'diff_price'=>$feed['diff_price'],
                        'cgder_id'=>$feed['purchaser_id'],
                        'cgder'=>$feed['purchaser'],
                        'supplierNo'=>$feed['supplier'],
                        'supplier_name'=>isset($supplier['name']) ? $supplier['name']:"",
                        'lasttime'=>$feed['expecttime'],
                        "addtime"=>date("Y-m-d H:i:s"),
                        "updatetime"=>date("Y-m-d H:i:s")
                    ];
                    $in= Db::name("purchease_order")->insert($data);
                    if($in){
                        Db::commit();
                        return app_show(0,"更新成功",['cgdNo'=>$inw]);
                    }
                }else{
                    Db::commit();
                    return app_show(0,"更新成功");
                }
            }
            Db::rollback();
            return error_show(1004,"更新失败");
        }catch (\Exception $e){
            Db::rollback();
            return error_show(1005,$e->getMessage());
        }
    }

}